/*******************************************************************************/
/* Function: MC4Self.DLL Loader 
/*			 Goldammer GmbH (C) 2005
/*
/* Date		  Dev						Comment
/* ----------------------------------------------------------------------------*/
/* 09.06.2005 Torsten Schinkel			Init Release
/*
/*
/*******************************************************************************/
//#ifdef __AFXWIN_H__
	#include "stdafx.h"
//#endif

#include <windows.h>
#include <stdio.h>

/*******************************************************************************/
/* Funktionsprototypen   												       */
/*******************************************************************************/
//-Main-------------------------------------------------------------------
int	(__stdcall	 *LoadCard)							(int CardID);
int	(__stdcall	 *OpenCard)							(int CardID);
int	(__stdcall	 *CloseCard)						(int CardID);
int	(__stdcall	 *SwitchCard)						(int CardID);

int (__stdcall   *ReadFlashData)					(int CardNr, void* BufferPtr);
int (__stdcall   *ReadFlashDataEx)					(int CardNr, void* BufferPtr);
//int (__stdcall   *GetEnhancedInformations)			(int CardNr, PEnhancedInformations DestinationPointer);
int (__stdcall   *ConfigCard)						(int Differenzmodus, int ADWandler, int DARange);

int (__stdcall   *CaptureOneChannel)				(int ChannelNumber, int Differenzmodus, int InputRange, void* ScaledValue, void* BinaryValue);
int (__stdcall   *CaptureOneChannelEx)				(int ChannelNumber, int Differenzmodus, int InputRange, int Gain, int Oversampling, int Bipolar,  double* ScaledValue, int* BinaryValue);
int (__stdcall   *ClearChannelLists)				(void);
int (__stdcall   *ClearChannelListsEx)				(int CardNr, int SWTakt, int SWSignalisierung);
int (__stdcall   *PrepareFilterEntry)				(int Channel, int Filtermode, int SampleFreq, 
													 double Freq1, double Freq2,
													 double Freq3, double Freq4,
													 double Passabsorption, double Stopbandattenuation,
													 int MaxOrder, 
													 int DesignMethod, 
													 int Filtertyp,
													 int Window, 
													 int Param1);
//-AD---------------------------------------------------------------------
int (__stdcall   *Add_AD_Channel_to_ScanList)		(int ChannelNumber, int Oversampling, int Gain, int Bipolar);
int (__stdcall   *Add_Dig_Channel_to_ScanList)		(int ChannelNumber, int Typ);
int (__stdcall   *Add_CT_Channel_to_ScanList)		(int ChannelNumber);
int (__stdcall   *SetADFrequency)					(int FrequencyPerChannel);
int (__stdcall   *SetADFrequencyEx)					(int FrequencyPerChannel, double* ReelleFrequenz, int* Basisfrequenz);
int (__stdcall   *FinalInit)						(void);
int (__stdcall   *StartADCapture)					(void);
int (__stdcall   *StartADCaptureEx)					(int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
int (__stdcall   *StopADCapture)					(void);
int (__stdcall   *GetScaledData)					(int InputRange, void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
int (__stdcall   *GetBinaryData)					(void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
int (__stdcall   *PutOneChannel)					(int ChannelNumber, int OutputRange, double ScaledValue);
int	(__stdcall	 *SendICPSettings)					(int CardID, void* ICPSettings);
//-DA---------------------------------------------------------------------
int (__stdcall   *Add_DA_Channel_to_ScanList)		(int ChannelNumber);
int (__stdcall   *Add_DA_Channel_to_ScanListEx)		(int ChannelNumber, int Buffertype, int BufferSize);
int (__stdcall   *SetDAFrequency)					(int FrequencyPerChannel);
int (__stdcall   *StartDAOutput)					(void);
int (__stdcall   *StartDAOutputEx)					(int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
int (__stdcall   *StopDAOutput)						(void);
int (__stdcall   *PutScaledData)					(int OutputRange, void* SourceBuffer, int NumberOfChannels, void* NumberPerChannel, int SkipLessData);
int (__stdcall   *PutBinaryData)					(void* SourceBuffer, int NumberOfChannels, void* NumberPerChannel, int SkipLessData);
int (__stdcall   *GetDAFreeBufferSpace)				(int CardID, int* FreeWordsPerChannel);
//-DIO--------------------------------------------------------------------
int (__stdcall   *SetDigitalDirection)				(int Channel, int Direction);
int (__stdcall   *ReadDigitalBit)					(int Channel, void* Value);
int (__stdcall   *WriteDigitalBit)					(int Channel, int Value);
int (__stdcall   *SetDigitalPortDirection)			(int StartChannel, int Bits, int Direction);
int (__stdcall   *ReadDigitalPort)					(int StartChannel, int Bits, int* Value);
int (__stdcall   *WriteDigitalPort)					(int StartChannel, int Bits, int Value);

int (__stdcall   *DIN_AddChannel_To_DINScanlist)	(int ChannelNumber, int Typ);
int (__stdcall   *SetDINFrequency)					(double Frequency);
int (__stdcall   *StartDINCapture)					();
int (__stdcall   *StartDINCaptureEx)				(int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
int (__stdcall   *StopDINCapture)					();
int (__stdcall   *DIN_GetBinaryData)				(int Channel, void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
int (__stdcall   *DIN_GetScaledData)				(int Channel, void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
int (__stdcall   *GetDINBufferStatus)				(int CardID, void* SampledValuesPerChannel);
//-CT---------------------------------------------------------------------
int (__stdcall   *ConfigureCounterInput)			(int ChannelNumber, 
													 int Countermode, 
													 int PresetValue,
													 int FrequencyResolution,
													 int Flanke,
													 int InkrementalSWReset, 
													 int InkrementalHWReset,
													 int InkrementalHWResetFlanke, 
													 int InkrementalInterpolation );
int (__stdcall   *ReadCounterValue)					(int ChannelNumber, void* Value);

int (__stdcall   *CT_AddChannel_To_CTScanlist)		(int Channel);
int (__stdcall   *SetCTFrequency)					(double Frequency);
int (__stdcall   *StartCTCapture)					();
int (__stdcall   *StartCTCaptureEx)					(int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
int (__stdcall   *StopCTCapture)					();
int (__stdcall   *CT_GetScaledData)					(void* DestinationBuffer, void* NumberPerChannel, int SkipLessData);
int (__stdcall   *GetCTBufferStatus)				(int CardID, void* SampledValuesPerChannel);
//-PWM--------------------------------------------------------------------
int (__stdcall   *PreparePWMOutput)					(int ChannelNumber, int BaseFrequency, int StartRatio);
int (__stdcall   *PrepareFMOutput)					(int ChannelNumber, int StartFrequency, int PulsWidthRatio);
int (__stdcall   *WriteNewPWMRatio)					(int ChannelNumber, int BaseFrequency, int Ratio);
int (__stdcall   *WriteNewFMRatio)					(int ChannelNumber, int Frequency, int PWRatio);
//-MM---------------------------------------------------------------------
int (__stdcall   *StartMemoryMeasurement)			(int CardID, int AnzahlKanaele, int ValuesPerChannel, int FrequencyPerChannel);
int (__stdcall   *StartMemoryMeasurementEx)			(int CardID, int AnzahlKanaele, int ValuesPerChannel, int FrequencyPerChannel, int UsualBlockSize);
int (__stdcall   *PrepareExtTrigger)				(int CardID, int ExtDigTrigger, int ExtDigTakt, int ExtDigFlanke);
int (__stdcall	 *GetMemoryMeasurementStatus)		(int CardID);
int (__stdcall	 *StopMemoryMeasurement)			(int CardID);
int	(__stdcall	 *DeInitMemoryMeasurement)			(int CardID);
int (__stdcall	 *ReadMemoryMeasurement)			(int CardID, int* UsedValues, int* FIFOSize);
int (__stdcall	 *GetScaledDataFromMemoryMeasurement)(int CardID,
													 int InputRange,
													 int AnzahlKanaele,
													 int ValuesPerChannel,
													 void* Destination,
													 int SkipIfLessData,
													 int* TransferedWords);
int (__stdcall	 *GetBinaryDataFromMemoryMeasurement)(int CardID,
													 int AnzahlKanaele,
													 int ValuesPerChannel,
													 void* Destination,
													 int SkipIfLessData,
													 int* TransferedWords);

//-Trigger----------------------------------------------------------------
int (__stdcall   *PrepareTriggerEntry)				(int Channel,
													 // Starttrigger
													 int StartTriggerAktiv,
													 double StartTriggerSchwelle1,
													 double StartTriggerSchwelle2,
	  												 int StartTriggerTyp,
													 int StartTriggerAbStart,
													 int StartTriggerMessung,
													 int StartTriggerSetTTL,
													 int StartTriggerTTLKlemme,
													 int StartTriggerTTLStartzustand,
													 int StartTriggerTTLFlanke,
													 // Stoptrigger
													 int StopTriggerAktiv,
													 double StopTriggerSchwelle1,
													 double StopTriggerSchwelle2,
													 int StopTriggerTyp,
													 int StopTriggerAbStart,
													 int StopTriggerMessung,
													 int StopTriggerSetTTL,
													 int StopTriggerTTLKlemme,
													 int StopTriggerTTLStartzustand,
													 int StopTriggerTTLFlanke,
													 // Generell
													 int Retriggerbar);
int (__stdcall   *PrepareTriggerTakt)				(int Channel, int AnzahlWerteProTakt, double Schwellwert, int Schwellenart);
//-OnlineF----------------------------------------------------------------
int (__stdcall   *PrepareFFTEntry)					(int Channel, 
													 int AnzahlPunkte, 
													 int Spektrum, 
													 double Gain,
													 int Fensterfunktion, 
													 double Parameter);
int (__stdcall   *PreparePIDEntry)					(int Channel,
													 double PAnteil,
													 double IAnteil,
													 double  DAnteil,
													 int  Reglerart,
													 double Gain,
													 double Sollwert,
													 double MinValue,
													 double MaxValue,
													 int  DAKanal,
													 int SampleFreq);
int (__stdcall   *GetFFTData)						(int KanalNrInListe, void* DestinationBuffer);
int (__stdcall   *GetDLLVersion)					(char *VString, int* V1, int* V2, int* V3);

int (__stdcall   *ProgramUserTimerFrequency)		(int CardID, int Delay_in_ms);
int (__stdcall   *StartUserTimer)					(int CardID, int EventHandle);
int (__stdcall   *StopUserTimer)					(int CardID);
int (__stdcall   *ShowDebugNumber)					(int Number);

// helps eliminate warnings
template<typename T, typename U> void assign(T& dest, U src) { dest = (T&)src; }


HINSTANCE Init_MC4SelfDLL(void)
{
	HINSTANCE hInst_DLL = NULL;
	
	hInst_DLL = LoadLibrary("mc4self.dll");
	int LoadWarning = 0;

	if (!hInst_DLL)
		return NULL;

	//--Main------------------------------------------------------------------
	assign(LoadCard, GetProcAddress(hInst_DLL, "LoadCard"));
	assign(OpenCard, GetProcAddress(hInst_DLL, "OpenCard"));
	assign(CloseCard, GetProcAddress(hInst_DLL, "CloseCard"));
	assign(SwitchCard, GetProcAddress(hInst_DLL, "SwitchCard"));

	assign(ReadFlashData, GetProcAddress(hInst_DLL, "ReadFlashData"));
	assign(ReadFlashDataEx, GetProcAddress(hInst_DLL, "ReadFlashDataEx"));
//	assign(GetEnhancedInformations, GetProcAddress(hInst_DLL, "GetEnhancedInformations"));
	assign(ConfigCard, GetProcAddress(hInst_DLL, "ConfigCard"));

	assign(CaptureOneChannel, GetProcAddress(hInst_DLL, "CaptureOneChannel"));
	assign(CaptureOneChannelEx, GetProcAddress(hInst_DLL, "CaptureOneChannelEx"));
	assign(ClearChannelLists, GetProcAddress(hInst_DLL, "ClearChannelLists"));
	assign(ClearChannelListsEx, GetProcAddress(hInst_DLL, "ClearChannelListsEx"));
	assign(PrepareFilterEntry, GetProcAddress(hInst_DLL, "PrepareFilterEntry"));

	//--AD--------------------------------------------------------------------
	assign(Add_AD_Channel_to_ScanList, GetProcAddress(hInst_DLL, "Add_AD_Channel_to_ScanList"));
	assign(Add_Dig_Channel_to_ScanList, GetProcAddress(hInst_DLL, "Add_Dig_Channel_to_ScanList"));
	assign(Add_CT_Channel_to_ScanList, GetProcAddress(hInst_DLL, "Add_CT_Channel_to_ScanList"));
	assign(SetADFrequency, GetProcAddress(hInst_DLL, "SetADFrequency"));
	assign(SetADFrequencyEx, GetProcAddress(hInst_DLL, "SetADFrequencyEx"));
	assign(FinalInit, GetProcAddress(hInst_DLL, "FinalInit"));
	assign(StartADCapture, GetProcAddress(hInst_DLL, "StartADCapture"));
	assign(StartADCaptureEx, GetProcAddress(hInst_DLL, "StartADCaptureEx"));
	assign(StopADCapture, GetProcAddress(hInst_DLL, "StopADCapture"));
	assign(GetScaledData, GetProcAddress(hInst_DLL, "GetScaledData"));
	assign(GetBinaryData, GetProcAddress(hInst_DLL, "GetBinaryData"));
	assign(PutOneChannel, GetProcAddress(hInst_DLL, "PutOneChannel"));
	assign(SendICPSettings, GetProcAddress(hInst_DLL, "SendICPSettings"));

	//-DA---------------------------------------------------------------------
	assign(Add_DA_Channel_to_ScanList, GetProcAddress(hInst_DLL, "Add_DA_Channel_to_ScanList"));
	assign(Add_DA_Channel_to_ScanListEx, GetProcAddress(hInst_DLL, "Add_DA_Channel_to_ScanListEx"));
	assign(SetDAFrequency, GetProcAddress(hInst_DLL, "SetDAFrequency"));
	assign(StartDAOutput, GetProcAddress(hInst_DLL, "StartDAOutput"));
	assign(StartDAOutputEx, GetProcAddress(hInst_DLL, "StartDAOutputEx"));
	assign(StopDAOutput, GetProcAddress(hInst_DLL, "StopDAOutput"));
	assign(PutScaledData, GetProcAddress(hInst_DLL, "PutScaledData"));
	assign(PutBinaryData, GetProcAddress(hInst_DLL, "PutBinaryData"));
	assign(GetDAFreeBufferSpace, GetProcAddress(hInst_DLL, "GetDAFreeBufferSpace"));

	//-DIO--------------------------------------------------------------------
	assign(SetDigitalDirection, GetProcAddress(hInst_DLL, "SetDigitalDirection"));
	assign(ReadDigitalBit, GetProcAddress(hInst_DLL, "ReadDigitalBit"));
	assign(WriteDigitalBit, GetProcAddress(hInst_DLL, "WriteDigitalBit"));
	assign(SetDigitalPortDirection, GetProcAddress(hInst_DLL, "SetDigitalPortDirection"));
	assign(ReadDigitalPort, GetProcAddress(hInst_DLL, "ReadDigitalPort"));
	assign(WriteDigitalPort, GetProcAddress(hInst_DLL, "WriteDigitalPort"));

	assign(DIN_AddChannel_To_DINScanlist, GetProcAddress(hInst_DLL, "DIN_AddChannel_To_DINScanlist"));
	assign(SetDINFrequency, GetProcAddress(hInst_DLL, "SetDINFrequency"));
	assign(StartDINCapture, GetProcAddress(hInst_DLL, "StartDINCapture"));
	assign(StartDINCaptureEx, GetProcAddress(hInst_DLL, "StartDINCaptureEx"));
	assign(StopDINCapture, GetProcAddress(hInst_DLL, "StopDINCapture"));
	assign(DIN_GetBinaryData, GetProcAddress(hInst_DLL, "DIN_GetBinaryData"));
	assign(DIN_GetScaledData, GetProcAddress(hInst_DLL, "DIN_GetScaledData"));
	assign(GetDINBufferStatus, GetProcAddress(hInst_DLL, "GetDINBufferStatus"));

	//-CT---------------------------------------------------------------------
	assign(ConfigureCounterInput, GetProcAddress(hInst_DLL, "ConfigureCounterInput"));
	assign(ReadCounterValue, GetProcAddress(hInst_DLL, "ReadCounterValue"));
	
	assign(CT_AddChannel_To_CTScanlist, GetProcAddress(hInst_DLL, "CT_AddChannel_To_CTScanlist"));
	assign(SetCTFrequency, GetProcAddress(hInst_DLL, "SetCTFrequency"));
	assign(StartCTCapture, GetProcAddress(hInst_DLL, "StartCTCapture"));
	assign(StartCTCaptureEx, GetProcAddress(hInst_DLL, "StartCTCaptureEx"));
	assign(StopCTCapture, GetProcAddress(hInst_DLL, "StopCTCapture"));
	assign(CT_GetScaledData, GetProcAddress(hInst_DLL, "CT_GetScaledData"));
	assign(GetCTBufferStatus, GetProcAddress(hInst_DLL, "GetCTBufferStatus"));

	//-PWM--------------------------------------------------------------------
	assign(PreparePWMOutput, GetProcAddress(hInst_DLL, "PreparePWMOutput"));
	assign(PrepareFMOutput, GetProcAddress(hInst_DLL, "PrepareFMOutput"));
	assign(WriteNewPWMRatio, GetProcAddress(hInst_DLL, "WriteNewPWMRatio"));
	assign(WriteNewFMRatio, GetProcAddress(hInst_DLL, "WriteNewFMRatio"));

	//-MM---------------------------------------------------------------------
	assign(StartMemoryMeasurement, GetProcAddress(hInst_DLL, "StartMemoryMeasurement"));
	assign(StartMemoryMeasurementEx, GetProcAddress(hInst_DLL, "StartMemoryMeasurementEx"));
	assign(PrepareExtTrigger, GetProcAddress(hInst_DLL, "PrepareExtTrigger"));	
	assign(GetMemoryMeasurementStatus, GetProcAddress(hInst_DLL, "GetMemoryMeasurementStatus"));
	assign(StopMemoryMeasurement, GetProcAddress(hInst_DLL, "StopMemoryMeasurement"));
	assign(DeInitMemoryMeasurement, GetProcAddress(hInst_DLL, "DeInitMemoryMeasurement"));
	assign(ReadMemoryMeasurement, GetProcAddress(hInst_DLL, "ReadMemoryMeasurement"));
	assign(GetScaledDataFromMemoryMeasurement, GetProcAddress(hInst_DLL, "GetScaledDataFromMemoryMeasurement"));
	assign(GetBinaryDataFromMemoryMeasurement, GetProcAddress(hInst_DLL, "GetBinaryDataFromMemoryMeasurement"));
	
	//-Trigger----------------------------------------------------------------
	assign(PrepareTriggerEntry, GetProcAddress(hInst_DLL, "PrepareTriggerEntry"));
	assign(PrepareTriggerTakt, GetProcAddress(hInst_DLL, "PrepareTriggerTakt"));

	//-OnlineF----------------------------------------------------------------
	assign(PrepareFFTEntry, GetProcAddress(hInst_DLL, "PrepareFFTEntry"));
	assign(PreparePIDEntry, GetProcAddress(hInst_DLL, "PreparePIDEntry"));
	assign(GetFFTData, GetProcAddress(hInst_DLL, "GetFFTData"));

	//-Misc-------------------------------------------------------------------	
	assign(GetDLLVersion, GetProcAddress(hInst_DLL, "GetDLLVersion"));
	assign(ProgramUserTimerFrequency, GetProcAddress(hInst_DLL, "ProgramUserTimerFrequency"));
	assign(StartUserTimer, GetProcAddress(hInst_DLL, "StartUserTimer"));
	assign(StopUserTimer, GetProcAddress(hInst_DLL, "StopUserTimer"));

	assign(ShowDebugNumber, GetProcAddress(hInst_DLL, "ShowDebugNumber"));

	
	if ( // Main
		 !LoadCard ||
		 !OpenCard ||
		 !CloseCard ||
		 !SwitchCard ||
		 !ReadFlashData ||
		 !ReadFlashDataEx ||
		 !ConfigCard ||
		 !CaptureOneChannel ||
		 !CaptureOneChannelEx ||
		 //!ClearChannelLists ||
		 !ClearChannelListsEx ||
		 //!PrepareFilterEntry ||
		 // AD
		 !Add_AD_Channel_to_ScanList ||
		 !Add_Dig_Channel_to_ScanList ||
		 !Add_CT_Channel_to_ScanList ||
		 !SetADFrequency ||
		 !SetADFrequencyEx ||
		 !FinalInit ||
		 !StartADCapture ||
		 !StartADCaptureEx ||
		 !StopADCapture ||
		 !GetScaledData ||
		 !GetBinaryData ||
		 //!PutOneChannel ||
		 // DA
		 /*
		 !Add_DA_Channel_to_ScanList ||
		 !Add_DA_Channel_to_ScanListEx ||
		 !SetDAFrequency ||
		 !StartDAOutput ||
		 !StartDAOutputEx ||
		 !StopDAOutput ||
		 !PutScaledData ||
		 !PutBinaryData ||
		 !GetDAFreeBufferSpace ||
		 */
		 // DIO
		 !SetDigitalDirection ||
		 !ReadDigitalBit ||
		 !WriteDigitalBit ||
		 !SetDigitalPortDirection ||
		 !ReadDigitalPort ||
		 !WriteDigitalPort ||
		 // Automatik Dig-IN
		 /*
		 !DIN_AddChannel_To_DINScanlist ||
		 !SetDINFrequency ||
		 !StartDINCapture ||
		 !StartDINCaptureEx ||
		 !StopDINCapture ||
		 !DIN_GetBinaryData ||
		 !DIN_GetScaledData ||
		 !GetDINBufferStatus ||
		 */
		 // CT
		 !ConfigureCounterInput ||
		 !ReadCounterValue ||
		 // Automatik CT-IN	
		 !CT_AddChannel_To_CTScanlist ||
		 !SetCTFrequency ||
		 !StartCTCapture ||
		 !StartCTCaptureEx ||
		 !StopCTCapture ||
		 !CT_GetScaledData ||
		 !GetCTBufferStatus //||

		 // PWM
		 /*
		 !PreparePWMOutput ||
		 !PrepareFMOutput ||
		 !WriteNewPWMRatio ||
		 !WriteNewFMRatio ||
		 */
		 // MM
		 /*
		 !StartMemoryMeasurement ||
		 !StartMemoryMeasurementEx ||
		 !PrepareExtTrigger ||
		 !GetMemoryMeasurementStatus ||
		 !StopMemoryMeasurement ||
		 !DeInitMemoryMeasurement ||
		 !ReadMemoryMeasurement ||
		 !GetScaledDataFromMemoryMeasurement ||
		 !GetBinaryDataFromMemoryMeasurement ||
		 */
		 // Trigger
		 /*
		 !PrepareTriggerEntry ||
		 !PrepareTriggerTakt ||
		 */
		 // OnlineF
		 /*
		 !PrepareFFTEntry ||
		 !PreparePIDEntry ||
		 !GetFFTData ||
		 */
		  // Misc
		  /*
		 !GetDLLVersion ||
		 !ProgramUserTimerFrequency ||
		 !StartUserTimer ||
		 !StopUserTimer ||

		 !ShowDebugNumber
		 */

		 ) {
		puts("[mc4self.dll] Couldn't get all entry points");
		FreeLibrary(hInst_DLL);
		return NULL;
	}
	
	return hInst_DLL;
}

BOOL DeInit_MC4SelfDLL(HINSTANCE hInst)
{
	if (hInst != NULL) {
		FreeLibrary(hInst);
		hInst = NULL;
		return TRUE;
	}

	return FALSE;
}
